-- Find new cooking and furniture recipes since last addon revision.

local FurnitureTypes = {
[1]		= 'Alchemy',
[2]		= 'Blacksmithing',
[3]		= 'Clothing',
[4]		= 'Enchanting',
[5]		= 'Provisioning',
[6]		= 'Woodworking',
}

local sMax = 4 -- This x 50000 is the max item ID range the script will search for (4 = 200000).

local function GetItemIdFromLink(itemLink) -- Parse the link data for base itemId.
	local itemId = select(4, ZO_LinkHandler_ParseLink(itemLink))
	return tonumber(itemId)
end

local function FindNewFurniture(category, stage)
	local cID = tonumber(category)
	if FurnitureTypes[cID] == nil then
		d('USE: Type /mrlfnf followed by a space then a number (1-6):')
		d('1=Alchemy 2=Blacksmithing 3=Clothing')
		d('4=Enchanting 5=Provisioning 6=Woodworking')
		return
	else
		local tempInt = (stage == 1) and 0 or 1
		local IdLow = (50000 * stage) - 50000
		local IdHigh = 50000 * stage	

		for i = IdLow, IdHigh, 1 do
			local tId = tostring(i+tempInt)
			local link = "|H1:item:" .. tId .. ":4:14:0:0:0:0:0:0:0:0:0:0:0:0:0:0:1:0:0:0|h|h"
			local linkstring = tostring(GetItemLinkName(link))
			local skillType = GetCraftingSkillName(GetItemLinkRecipeCraftingSkillType(link))
			local skipcooking = (cID == 5 and string.find(linkstring, 'Recipe:') ~= nil) and true or false

			if (skillType == FurnitureTypes[cID] and skipcooking == false and ESOMRL.RecipeFMaterials[i+tempInt] == nil) then
				local itemLink = GetItemLinkRecipeResultItemLink(link)
				local toQuality = GetItemLinkQuality(link)
				local toQualityText = GetString("SI_ITEMQUALITY", toQuality)
				local output = "ID #" .. tId .. ": " .. link .. " -- " .. "ID #" .. tostring(GetItemIdFromLink(itemLink)) .. ": " .. itemLink .. " -- " .. skillType .. " -- " .. toQualityText .. " -- " .. toQuality
				d(output)
			end
			if i == IdHigh then
				if stage == sMax then
					d("Finished searching.")
					return 
				else
					zo_callLater(function() FindNewFurniture(cID, stage+1) end, 500)
					return
				end
			end
		end
	end
end

local function FindNewRecipes(stage)
	local tempInt = (stage == 1) and 0 or 1
	local IdLow = (50000 * stage) - 50000
	local IdHigh = 50000 * stage	

	for i = IdLow, IdHigh, 1 do
		local tId = tostring(i+tempInt)
		local link = "|H1:item:" .. tId .. ":4:14:0:0:0:0:0:0:0:0:0:0:0:0:0:0:1:0:0:0|h|h"
		local linkstring = tostring(GetItemLinkName(link))
		local skillType = GetCraftingSkillName(GetItemLinkRecipeCraftingSkillType(link))
	--	local rSkip = (string.find(linkstring, 'Recipe:') ~= nil and ESOMRL.RecipeMaterials[i+tempInt] == nil) and true or false

	--	if skillType == 'Provisioning' and rSkip then
		if skillType == 'Provisioning' and ESOMRL.RecipeMaterials[i+tempInt] == nil and ESOMRL.ResultMaterials[i+tempInt] == nil and ESOMRL.RecipeFMaterials[i+tempInt] == nil and ESOMRL.ResultFMaterials[i+tempInt] == nil then
			local toQuality = GetItemLinkQuality(link)
			local toQualityText = GetString("SI_ITEMQUALITY", toQuality)
			local itemLink = GetItemLinkRecipeResultItemLink(link)
			local output = "ID #" .. tId .. ": " .. link .. " -- " .. "ID #" .. tostring(GetItemIdFromLink(itemLink)) .. ": " .. itemLink .. " -- " .. skillType .. " -- " .. toQualityText .. " -- " .. toQuality
			d(output)
		end

		if i == IdHigh then
			if stage == 4 then
				d("Finished searching.")
				return 
			else
				zo_callLater(function() FindNewRecipes(stage+1) end, 500)
				return
			end
		end
	end
end

local function NewFurniture(text)
	local category = text:gsub('%W',''):lower()
	FindNewFurniture(category, 1)
	return
end

local function NewRecipes(text)
	FindNewRecipes(1)
	return
end

SLASH_COMMANDS["/mrlfnf"] = NewFurniture
SLASH_COMMANDS["/mrlfnr"] = NewRecipes
